/*****************************************************************************
 *
 * proxjs-full.js -- external script for sidki's Proxomitron config
 *
 * This is the full version, used in "light config mode" and above.
 *
 * Last edited: 2007-09-05
 *
 *****************************************************************************/

/* ====================================
   Set some flags -- The "prxO" object has been created already.
   ==================================== */

// Page Load Timer Part I. - hpguru
if (prxO.oSet.$toDo & 16) prxO.oiLdStart = new Date().getTime();

// This flag indicates where we currently are in our script. Three stages:
// 0 -> Beginning.
// 1 -> End of page.
// 2 -> Onload event has completed.
var prxCountLd = 0;

// Detect Mozilla, IE, Opera. - hpguru
window.opera ? prxO.oiIsOp = true : document.getElementById ? document.all ?
  prxO.oiIsIE = true : prxO.oiIsMoz = true : prxO.oiIsIE = false;

// Force offscreen buffering to speed up rendering, default is auto. - hpguru
if (prxO.oiIsIE) window.offscreenBuffering = true;

// Does this browser support cssText and/or XPath?
prxO.oiTcss = typeof document.documentElement.style.cssText != "undefined";
prxO.oiXpath = !!document.evaluate;

// Is this a normal stand-alone window?
prxO.oiWinNormal = !window.opener || window.name.indexOf("prx_") == 0;

/* ====================================
   Required References and Declarations.
   ==================================== */

// May get overwritten.
prxO.oiDate = Date;
prxO.oiUesc = unescape;
document.PrxRLcreateElement = document.createElement;

// Replaced browser info.
document.PRXreferrer = unescape(prxO.oNce.ncFrom);
navigator.PRXuserAgent = prxO.oNce.ncWith;

// Works its way up to the top window later.
prxO.oTop = window;

// Dummies.
var prxVoidV = "";
function PrxVoidF() { return ""; }

// Prophylactic definitions.
var expires = new Date(0);
document.PRXcookie = "ProxMessage=GoFigureItOut";

// Called by Proxomitron instead of the real names.
if (prxO.oiIsMoz) {
  Window.prototype.PrxRLsetTimeout = Window.prototype.setTimeout;
  Window.prototype.PrxRLsetInterval = Window.prototype.setInterval;
} else {
  PrxRLsetTimeout = window.setTimeout;
  PrxRLsetInterval = window.setInterval;
}

/* ====================================
   Namespace for internal routines. - ...
   ==================================== */

prxO.oInt = {

  // Choose the right method for creating and getting tags, depending on
  // whether an XML namespace is present or not.
  inMakeEl : function (el) {
    return prxO.oSet.$_xns ? document.createElementNS(prxO.oSet.$_xns, el) :
      document.PrxRLcreateElement(el);
  },
  inGetEl : function (el) {
    return prxO.oSet.$_xns ? document.getElementsByTagNameNS(prxO.oSet.$_xns, el) :
      document.getElementsByTagName(el);
  },

  // Choose the right method for setting the style attribute value.
  inSetCSS : function (node, css) {
    if (prxO.oiTcss) node.style.cssText = css;
    else node.setAttribute("style", css);
  },

  // Checks if the given target refers to an existing frame or window.  Special
  // target names are ok.  Names starting with prx_ (e.g. bookmarklet windows)
  // are ok.  If the target matches an existing frame, ok.  Otherwise, no soup
  // for you. - Paul Rupe
  inTgCheck : function (t) {
    var n;
    return (
      t == "_top" || t == "_parent" || t == "_self" || t == "_content" ||
      t == "_main" || t.indexOf("prx_") == 0 ||
      (!!(n = prxO.oTop.prxO.oiNames) && n.indexOf("," + t + ",") != -1)
    );
  },

  // Open link targets that refer to non-existing windows in the top window.
  // - Paul Rupe, sidki, z12
  inTgLinks : function () {
    if (!(prxO.oSet.$toDo & 32)) return;

    // Check if given node or its first child have an onclick attribute.
    function noClick(nd) {
      return !(nd.getAttribute("onclick") || (nd = nd.firstChild) && nd.onclick);
    }

    // Maximum links to check.
    var l = 1200, i, f, t, d, s;

    // Check for XPath support, fall back to links collection, fall back to
    // getElementsByTagName.
    if (prxO.oiXpath) {
      t = []; d = document.evaluate(
        "//a[@target and not(starts-with(@href, 'javascript:')) and not(starts-with(@class, 'Prox'))]",
        document, null, 0, null);
      while ((f = d.iterateNext()) && (s = t.length) < l)
        if (!this.inTgCheck(f.target) && noClick(f)) t[s] = f;
      for (i = 0; f = t[i]; i++) f.target = "_top";
    } else {
      d = document.links || this.inGetEl("a");
      if (d.length > l) return;
      for (i = 0; f = d[i]; i++) {
        if ((t = f.target) && f.protocol != "javascript:" &&
            f.className.indexOf("Prox") != 0 &&
            !this.inTgCheck(t) && noClick(f))
          f.target = "_top";
      }
    }

  },

  // Temporary handles for the W3C and IE event unregistration methods.
  inEventRemT : prxO.oiIsIE ? window.detachEvent : window.removeEventListener,

  // Cross-browser event listener registration and unregistration
  // - Mozilla/IE/Opera/NN4. - Scott Andrew LePera
  inEventAdd : function (obj, evn, fn, cap) {
    var rl = (obj == window || obj == document) ? "PrxRL" : "";
    if (!prxO.oiIsIE && obj.addEventListener)
      obj[rl + "addEventListener"](evn, fn, cap || false);
    else if (obj.attachEvent)
      obj[rl + "attachEvent"]("on" + evn, fn);
    else obj["on" + evn] = fn;
  },
  inEventRem : function (obj, evn, fn, cap) {
    if (!prxO.oiIsIE && obj.removeEventListener) {
      if (this.inEventRemT) {
        window.removeEventListener = this.inEventRemT;
        delete this.inEventRemT;
      }
      obj.removeEventListener(evn, fn, cap || false);
    } else if (obj.detachEvent) {
      if (this.inEventRemT) {
        window.detachEvent = this.inEventRemT;
        delete this.inEventRemT;
      }
      obj.detachEvent("on" + evn, fn);
    }
  },

  // Set some of an object's event handlers to null Part I. - Paul Rupe
  inClearEvent : function (pxA) {
    if (!pxA) return;
    var pxE = [
      "onmouseleave",
      "onmouseout",
      "onmousewheel",
      "onblur",
      "onfocus",
      "onfocusout",
      "oncontextmenu",
      "ondeactivate",
      "onhelp",
      "onlosecapture",
      "onpropertychange",
      "onscroll",
      "onselect",
      "onselectstart",
      "onbeforeunload",
      "onunload"
    ];

    if (this.in_onclick) pxE[pxE.length] = "onclick";
    if (this.in_onmousedown) pxE[pxE.length] = "onmousedown";
    if (this.in_onmouseup) pxE[pxE.length] = "onmouseup";
    if (this.in_onbeforeprint) pxE[pxE.length] = "onbeforeprint";
    if (this.in_onafterprint) pxE[pxE.length] = "onafterprint";
    if (this.in_onresize) pxE[pxE.length] = "onresize";

    // Asking the Document object for defined event handlers is slow,
    // so nullify them unconditionally there.
    for (var i = 0, pxO; pxO = pxE[i]; i++)
      if (pxA == document || pxA[pxO]) pxA[pxO] = null;
  },

  // Create Popup Blocked Notification. - Michael Brschgens, JD
  inPopURL : function (url) {
    if (prxO.oSet.$popUp < 2) return;
    var s, f = "http://local.ptron/sidki_h_"; f += prxO.oSet.$_cfg; f += "/pop-";

    // Append image link.
    if (prxO.oSet.$popUp & 2) {
      var l = prxO.oInt.inMakeEl("a"),
      p = prxO.oInt.inMakeEl("img");
      p.src = f + (url ? "link.gif" : "blind.gif");
      p.title = "Popup blocked: " + url;
      p.className = "ProxPop-Img"; p.width = 17; p.height = 17; p.border = 0;
      l.href = url; l.target = "_top"; l.appendChild(p);
      this.inDOMready(l);
    }

    // Append sound tag.
    if (prxO.oSet.$popUp & 4) {
      if (prxO.oiIsIE) s = prxO.oInt.inMakeEl("bgsound");
      else if (prxO.oiIsOp) {
        s = prxO.oInt.inMakeEl("iframe");
        s.width = 0; s.height = 0; s.frameBorder = 0;
      } else {
        s = prxO.oInt.inMakeEl("embed");
        s.setAttribute("hidden", true);
      }
      s.src = f + "up.wav";
      this.inDOMready(s);
    }
  },

  // Print messages dynamically to the footer. - sidki
  inFooter : function (level, title, msg) {
    if (prxO.oSet.$_level < level) return;
    msg = (typeof msg == "string") ? msg.replace(/\n/g, "//") : msg;
    var tag = prxO.oInt.inMakeEl("span");
    tag.className = "Prox";
    tag.style.display = "inline";
    // Use createTextNode instead of innerHTML to get formatting right.
    tag.appendChild(document.createTextNode(" \u2022\u00A0" + title + ": " + msg));
    this.inDOMready(tag);
  },

  // Adds supplied elements to an array, until the entire page is accessible
  // via the DOM. - sidki
  inDOMready : function (tag) {
    if (this.inDivNode.id) this.inDivNode.appendChild(tag);
    else {
      if (!prxO.oNce) return;
      if (!prxO.oNce.ncColl) prxO.oNce.ncColl = [];
      prxO.oNce.ncColl[prxO.oNce.ncColl.length] = tag;
    }
  },

  // Declare the style selector. - Tantek Celik
  inStyleSwitch : function () {
    var sheets = ",", options = "<option selected>document default</option>";
    for (var i = 0, d = document.styleSheets; i < d.length; i++) {
      var s = d[i], tt = s.title;
      if (tt != "" && tt != undefined)
        if (sheets.indexOf("," + tt + ",") == -1) {
          sheets += tt; sheets += ",";
          options += "<option>"; options += tt; options += "</option>";
        }
    }
    var dw = this.inMyPop("", ",width=201,height=124").document;
    dw.write(
      "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n\"http://www.w3.org/TR/html4/strict.dtd\">" +
      "\n<html><head><title>Select Stylesheet</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">" +
      "\n<style type=\"text/css\">\nbody{margin:0;font:12px/20px Verdana,Arial,sans-serif;background:#CEDFEF;}" +
      "\ndiv{margin:0;padding:15px 10px 15px 10px}\nselect{width:170px;background:#A5CFF7;}\n</style>" +
      "\n<script type=\"text/javascript\">\nfunction choosess(tt){var x=window.opener.document;" +
      "for(var i=0,d=x.styleSheets;i<d.length;i++){var s=d[i];var ti=s.title;if(ti!=\"\" && ti!=undefined && ti!=tt)s.disabled=true;else s.disabled=false;}}\n</script>" +
      "\n</head>\n<body>\n<div>" +
      "\n<select id=\"st\" size=5 onkeypress=\"var k=event.keyCode;if(k==13 || k==3 || k==27){window.close()}\"" +
      " onchange=\"if(this.selectedIndex!=-1)choosess(this.options[this.selectedIndex].text);\">" + options + "</select>" +
      "\n</div>\n</body></html>"
    );
    dw.close(); dw.getElementById("st").focus();
  },

  // Proxomitron's own popups.  Needed for pages that block direct access to
  // the "open" method later on. - sidki
  inMyPop : function (w1, w2) {
    var x = (typeof PrxRLopen != "undefined") ? PrxRLopen : window.open;
    if (!w2) return x(w1, "_blank");
    var xatr  = "location=0,status=0,scrollbars=1,status=0,menubar=0,resizable=1,left=";
    xatr += screen.width * .01; xatr += ",top=";
    xatr += prxO.oiIsOp ? screen.height * .05 : screen.height * .12; xatr += w2;
    return x(w1, "prx_menu", xatr);
  },

  // Get the direct link to the intercepted Flash on mouseover. - z12, sidki
  inGetFlash : function (node) {
    var mom = node.parentNode;
    while (mom.className.indexOf("ProxFlash") != 0) mom = mom.parentNode;
    var mov, obj = mom.nextSibling, typ = obj.tagName.toLowerCase();
    if (typ == "span") {
      obj = obj.firstChild; typ = obj.tagName.toLowerCase();
    }
    if (prxO.oiIsIE) mov = obj.rmov || obj.Movie || obj.SRC;
    else {
      if (typ == "embed") mov = obj.getAttribute("src");
      else if (typ == "object" && !(mov = obj.data) && prxO.oiXpath)
        mov = document.evaluate(
         "param[translate(@name, 'MOVIE', 'movie')='movie' or translate(@name, 'SRC', 'src')='src']",
          obj, null, 9, null).singleNodeValue.value;
    }

    if (mov) node.href = mov;
    node.onmouseover = null;
  },

  // Get the 'n'th ancestor of given node. - Sadiq
  inGoUp : function (node, n) {
    for (var i = 0; i < n; i++) node = node.parentNode; return node;
  },

  // Toggle (show/hide) specified tags. - sidki
  inToggleA : function () {
    for (var i = 0, pxA, pxH; pxA = arguments[i]; i++) {
      if (pxA.style.display == "none" || pxA.style.visibility == "hidden") {
        if (prxO.oiIsIE) {
          pxA.style.display = "inline"; pxA.style.visibility = "visible";
        } else {
          pxH = prxO.oiTcss ? pxA.style.cssText : pxA.getAttribute("style");
          pxH = pxH.replace(/((display|visibility): *(none|hidden)[; ]*)+/i, "");
          pxH ? prxO.oInt.inSetCSS(pxA, pxH) : pxA.removeAttribute("style");
        }
      } else { pxA.style.display = "none"; pxA.style.visibility = "hidden"; }
    }
  },
  inToggleB : function (nam, atr, tags, num) {
    var m, i, a, t, tagThis, tagArray = tags.split(",");
    num = num || 0;
    for (m = 0; a = tagArray[m]; m++) {
      tagThis = this.inGetEl(a);
      for (i = 0; t = tagThis[i]; i++)
        if ((atr == "cl" && nam == t.className.split(" ")[num]) ||
          (atr == "id" && nam == t.id)) {
          if (nam == "ProxFlash") this.inToggleD(t);
          else this.inToggleA(t);
        }
    }
  },
  inToggleC : function (nam, tag) {
    if (!tag) {
      nam.src = nam.longDesc; nam.style.display = "inline";
    } else {
      var i, t, tagThis = this.inGetEl(tag);
      for (i = 0; t = tagThis[i]; i++) {
        if (t.className.indexOf(nam) == 0) {
          if (t.style.display == "none") {
            t.src = t.longDesc; t.style.display = "inline";
          } else {
            t.src = "about:blank"; t.style.display = "none";
          }
        }
      }
    }
  },
  inToggleD : function (pxA, pxT) {
    function doTog(pA, pT) {
      if (pA.className == "ProxFlash") {
        if (prxO.oiIsIE) {
          var pB = (pA.Movie || pA.SRC) ? pA : pA.firstChild;
          if (pB.rmov) {
            var pC = pB.Movie ? "Movie" : "SRC";
            if (pB[pC] == "about:blank") pB[pC] = pB.rmov;
          }
        }
      }
      else if (pT) {
        while (pxA.className.indexOf("ProxToggle") < 0) pxA = pxA.parentNode;
        pA = pxA;
      }
      pA.style.display = (pA.style.display == "none") ? "inline" : "none";
    }
    doTog(pxA, true);
    if (pxT) doTog(pxA.nextSibling);
  }

};

/* ====================================
   Namespace for initial temporary functions.
   ==================================== */

prxO.oNce = {
  ncDocFrag : document.createDocumentFragment(),

  // Get Window Names Part I.  If this window has a name, append it to the
  // "Frame Names" variable. - z12
  ncTgAdd : function (s) {
    var t = s.name;
    if (!t) return;
    var n = prxO.oTop.prxO.oiNames, m = "," + t + ",";
    if (!n) prxO.oTop.prxO.oiNames = m;
    else if (n.indexOf(m) == -1) prxO.oTop.prxO.oiNames += t + ",";
  },

  // Insert our stylesheet.
  ncCSSAdd : function () {
    var pxT = prxO.oInt.inMakeEl("style"),
    pxE = "a:visited", pxF = "left:auto!important;top:auto!important;",
    pxA = ((prxO.oSet.$css & 8) ? "" : "http:/");
    pxA += "/local.ptron/sidki_h_"; pxA += prxO.oSet.$_cfg;
    pxA += "/CSS/dummy.css?join="; pxA += prxO.oSet.$_cssSpec.join();
    pxT.media = "all"; pxT.type = "text/css"; pxT.id = "proxCSS";
    if (!prxO.oiIsIE) pxT.innerHTML = "@import url(" + pxA + ");" +
      ((prxO.oSet.$css & 1) ? pxE + "{" + pxF + "}" : "");
    document.getElementById("proxScrHead").parentNode.appendChild(pxT);
    if (prxO.oiIsIE) {
      pxT.styleSheet.addImport(pxA);
      if (prxO.oSet.$css & 1) pxT.styleSheet.addRule(pxE, pxF);
    }
  },

  // Return the properly formatted button code to an innerHTML call.
  ncButString : "",
  ncButCreate : function (pxO, pxN, pxF, pxB) {

    // Escape function code for display.
    pxF = pxF.replace(/&/g, "&amp;");
    pxF = pxF.replace(/</g, "&amp;lt;");
    pxF = pxF.replace(/>/g, "&gt;");
    pxF = pxF.replace(/\r/g, "");
    pxF = pxF.replace(/\n/g, "%3Cbr class=%22ProxFly-Br%22 />");
    pxF = pxF.replace(/"/g, "&quot;");
    pxF = pxF.replace(/'/g, "&amp;#39;");
    pxF = pxF.replace(/\\/g, "&amp;#92;");

    return "<input class=\"ProxBtn-Input\" type=\"button\" value=\"" + pxN +
      "\" onmouseover=\"prxO.oFly.flShow('%3Cdiv id=%22proxFlyCt-Div%22>" +
      "%3Cspan class=%22ProxFly-Span%22>scope: " + pxO +
      ":%3C/span>%3Cbr class=%22ProxFly-Br%22 />" + pxF +
      "%3C/div>',event,0);\" onmouseout=\"prxO.oFly.flDHide();\" onclick=\"" +
      pxB + "();\" />";
  },

  // Various Events to Buttons Part I. - Paul Rupe, sidki
  // Create a button to call a given event handler directly if such a handler
  // is defined.  Rather than disable e.g. window.onload completely, this lets
  // you call it at will in case some page requires it to function.
  ncButEvent : function (pxO, pxN, pxE, pxI) {

    // See if the passed handler function is block-worthy or not.
    if (prxO.oInt["in_" + pxN] !== undefined) return "";
    var pxT = (pxO == "document") ? document : (pxO == "prxO.oBody") ?
      prxO.oBody : window, pxP = pxT[pxN];
    if (!pxP) return "";
    if (typeof pxP != "function") {
      prxO.oInt.inFooter(4, "Prox intercept", "Can't convert " +pxO + "." + pxN + "!");
      prxO.oInt["in_" + pxN] = true;
      return "";
    }
    var pxF = pxP.toString(), skip = (pxE && pxF.search(pxE) != -1);
    if (!skip && pxI) skip = (pxF.search(pxI) == -1);
    prxO.oInt["in_" + pxN] = !skip;
    if (skip) return "";

    // It is block-worthy, so create a button.
    pxT["PrxRL" + pxN] = pxP;
    return this.ncButCreate(pxO, pxN, pxF, pxO + ".PrxRL" + pxN);
  },

  // Various Event Listeners to Buttons Part II. - sidki
  ncButListen : function (scope, evn, fn, cap) {
    if (!fn) return false;
    var that = this, ceci = arguments.callee, pxA = (typeof cap == "boolean");
    if (!pxA) evn = evn.substr(2);

    function lTest(pxB, pxZ, pxE, pxI) {

      // See if the passed listener is block-worthy or not.
      if (pxZ != evn) return false;
      if (that.ncCatch)
        for (var i = 0, l; l = that.ncCatch[i]; i++)
          if (l == [scope, evn, fn, cap].toString()) return true;
      var pxF = fn.toString(), skip = (pxE && pxF.search(pxE) != -1);
      if (!skip && pxI) skip = (pxF.search(pxI) == -1);
      if (skip) return false;
      if (!pxB) return true;

      // It is block-worthy, so create a button.
      ceci.count = ++ceci.count || 1;
      var pxO = scope.toString(); pxO += pxA ? " -- capture: " + cap : "";
      var pxT = pxA ? "listen: " : "attach: "; pxT += evn;
      var pxL = "in$"; pxL += evn; pxL += "_"; pxL += ceci.count;
      prxO.oInt[pxL] = fn;
      that.ncButString += that.ncButCreate(pxO, pxT, pxF, "prxO.oInt." + pxL);
      if (!that.ncCatch) that.ncCatch = [];
      that.ncCatch[that.ncCatch.length] = [scope, evn, fn, cap];
      return true;
    }

    // Test the current listener.
    var moEx = /\.altKey/,
    moIn = /open ?\(|\.((src|href) ?=|button ?== ?2)/;
    return (
      lTest(1, "click", moEx, moIn) ||
      lTest(1, "mousedown", moEx, moIn) ||
      lTest(1, "load", null, /Math\.random|\.createElement ?\( ?["']script|expires ?=/i) ||
      lTest(1, "contextmenu") ||
      lTest(1, "error") ||
      lTest(0, "beforeunload") ||
      lTest(0, "unload")
    );
  },

  // Executed at end of page.
  ncBottom : function (wdisp, wcook, wcode) {

    // Register our onload event Part II (removal). - sidki
    // The previous registration was needed for framesets, which won't see this
    // part of code.  And for IE, which is excluded.
    if (!prxO.oiIsIE) prxO.oInt.inEventRem(window, "load", this.ncLoad);

    // Prevent Window Resizing Part II.  If this is a requested popup, resize
    // it to the dimensions that may have been blocked previously.
    if (!prxO.oiWinNormal && prxO.oSet.$toDo & 64 && window.innerWidth) {
      if (window.PRXinnerWidth) window.innerWidth = window.PRXinnerWidth;
      else if (window.PRXouterWidth) window.outerWidth = window.PRXouterWidth;
      if (window.PRXinnerHeight) window.innerHeight = window.PRXinnerHeight;
      else if (window.PRXouterHeight) window.outerHeight = window.PRXouterHeight;
    }

    // Various Event Listeners to Buttons Part III (end of page). - sidki
    // Stop intercepting event listener registration now.
    if (prxO.oSet.$toButton & 2) {
      if (window.PrxRLaddEventListener) {
        window.addEventListener = window.PrxRLaddEventListener;
        document.addEventListener = document.PrxRLaddEventListener;
      }
      if (window.PrxRLattachEvent) {
        window.attachEvent = window.PrxRLattachEvent;
        document.attachEvent = document.PrxRLattachEvent;
      }
    }

    // Specific "onload" Events to Button - Paul Rupe, sidki
    if (prxO.oSet.$toButton & 4 && window.onload && !prxO.oiWinTiny && prxO.oiWinNormal) {
      var ldIn = /^\n*function SymOnLoad|^[^;]*p(opu(p|nder)|rint)|\.location(\.href|) ?=[^=]|Math\.random|float *[^:]|expires ?=/i;
      this.ncButString += this.ncButEvent("window", "onload", /menu|<frameset/i, ldIn);
      if (prxO.oInt.in_onload)
        window.onload = document.body.onload = null;
    }

    // "onerror" Events to Button - sidki
    if (prxO.oSet.$toButton & 1) {
      this.ncButString += this.ncButEvent("window", "onerror", /^\n*function \(pxMsg/);
      if (prxO.oInt.in_onerror)
        window.onerror = prxO.oSet._catchErrors ? prxO.oNce.ncOnerror : null;
    }

    this.ncWrite = function () {

      // Reinsert our CSS, if removed by a page script.
      if (prxO.oSet.$_cssSpec.length && !document.getElementById("proxCSS"))
        prxO.oNce.ncCSSAdd();

      // Set a reference to the body element.  Don't use "document.body" here,
      // "body" is a valid name for tag IDs.
      prxO.oBody = prxO.oInt.inGetEl("body")[0];

      // Set the main target element.  Values depend on rendering mode and
      // browser.
      prxO.oiMode = document.compatMode || (prxO.oSet.$_xns ? "XHTML" : "");
      if ((prxO.oiIsOp || (prxO.oiMode != "CSS1Compat" && !prxO.oSet.$_xns)) && prxO.oBody)
        prxO.oDoc = prxO.oBody;
      else prxO.oDoc = document.documentElement;

      // Check if this window is large enough to display Prox menu and bottom
      // links. - sidki
      var xc = prxO.oDoc.clientWidth, yc = prxO.oDoc.clientHeight,
      xs = prxO.oDoc.scrollWidth, ys = prxO.oDoc.scrollHeight;
      if ((prxO.oiWinShort = ys <= yc) && prxO.oiIsMoz && xs > xc) prxO.oiWinShort = 2;
      if (window.parent != window && prxO.oSet.$_level < 5) {
        // Fx2 returns incorrect client width/height under heavy CPU load.
        var x = window.innerWidth || xc, y = window.innerHeight || yc;
        x = (xs > x) ? xs : x;
        y = (ys > y) ? ys : y;
        prxO.oiWinTiny = x < 370 || y < 370;
      }

      // Adjust flyovers and Prox menu for non-statically positoned body elements
      // and for styled html elements in Mozilla.
      prxO.oiWidth = 0;
      var bStyle = document.defaultView ?
        document.defaultView.getComputedStyle(prxO.oBody, null) :
        prxO.oBody.currentStyle;
      if (bStyle && bStyle.position != "static")
        prxO.oiWidth = prxO.oiIsIE ? prxO.oBody.offsetLeft : (
          prxO.oiIsOp ? prxO.oBody.clientWidth - bStyle.pixelWidth :
          Math.round(prxO.oDoc.clientWidth - parseFloat(bStyle.width) -
          parseFloat(bStyle.paddingLeft) - parseFloat(bStyle.paddingRight))
          ) / 2;
      // if (prxO.oiWidth)
      //   prxO.oInt.inFooter(4, bStyle.position + " body x-adjust", prxO.oiWidth + "px");

      if (wdisp) {
        var w = [];

        // Prepare the bottom links, if any.
        if (!prxO.oiWinTiny) {
          var kills, rdisp = (wdisp == "none") ? wdisp : "inline";

          // Any incoming ad scripts?
          if ((kills = prxO.oNce.ncJsKills)) {
            var q, kill, justin = "";
            for (q = 0; kill = kills[q]; q++) {
              justin += "%3Cspan class=%22ProxFly-Span%22>";
              justin += kill[0]; justin += ":%3C/span> "; justin += kill[1];
              justin += "%3Cbr class=%22ProxFly-Br%22 />";
            }
            w[w.length] = "<span class=\"ProxAlert Prox\" style=\"display:";
            w[w.length] = rdisp; w[w.length] = "\">&#8226;&#160;<a class=\"ProxAlert Prox\"";
            w[w.length] = " onmouseover=\"prxO.oFly.flShow('%3Cdiv id=%22proxFlyCt-Div%22>";
            w[w.length] = justin; w[w.length] = "%3C/div>',event,0);\"";
            w[w.length] = " onmouseout=\"prxO.oFly.flDHide();\">js in</a> </span>";
          }

          // See if Proxomitron has already captured any info.
          w[w.length] = wcode || "";

          // See if we want to display cookies, and if Proxomitron has captured
          // any already.
          if (wcook) {
            wcook = (wcook == 1) ? "" : wcook;
            var cd = "", dc = document.cookie;
            if (dc) {

              // Zap cookies on button click. - Jesse Ruderman
              prxO.oInt.inCookieZ = function () {
                var dom, sl, su, pa, pa2, i, coI, coA = document.cookie.split("; "),
                ex = new prxO.oiDate(new prxO.oiDate().getTime() - 1e11).toGMTString();
                for (dom = "." + location.host; dom; dom = ("" + dom).substr(1).match(/\..*$/))
                  for (sl = 0; sl < 2; ++sl)
                    for (pa = "/" + location.pathname; pa; pa = pa.substring(0, pa.lastIndexOf("/"))) {
                      pa2 = pa.slice(1) + "/";
                      for (su = 0; su < 2; ++su)
                        for (i = 0; coI = coA[i]; i++)
                          document.cookie = coI + "; domain=" + dom.slice(sl) +
                            "; path=" + pa2.substr(0, pa2.length - su) + "; expires=" + ex;
                    }
              }

              dc = dc.replace(/;\s?/g, ";%3Cbr class=%22ProxFly-Br%22 />&#160;");
              dc = dc.replace(/</g, "&amp;lt;");
              dc = dc.replace(/\\/g, "&amp;#92;");
              dc = dc.replace(/"/g, "&amp;quot;");
              dc = dc.replace(/'/g, "&amp;#39;");
              wcook += "%3Cdiv class=%22ProxFlyCk-Div%22>Cookies in Session:%3C/div>&#160;";
              wcook += dc; wcook += "%3C/div>%3Cbutton class=%22ProxMBut%22 ";
              wcook += "onclick=%22prxO.oInt.inCookieZ();%22>Remove Cookies%3C/button>";
            }
            else cd = wcook ? " style=\"text-decoration:line-through!important\"" : cd;

            if (wcook) {
              w[w.length] = "<span class=\"ProxCookie Prox\""; w[w.length] = cd;
              w[w.length] = ">&#8226;&#160;<a class=\"ProxCookie Prox\" onmouseover=";
              w[w.length] = "\"prxO.oFly.flShow('%3Cdiv id=%22proxFlyCt-Div%22>";
              w[w.length] = wcook; w[w.length] = "',event,0);\"";
              w[w.length] = " onmouseout=\"prxO.oFly.flDHide();\">cookies</a>\n\t</span>";
            }
          }

          // See if we should display a "toggle all Flash objects" bottom link.
          if (prxO.oiFlash) {
            w[w.length] = "<span class=\"ProxToggleI Prox\" style=\"display:"; w[w.length] = rdisp;
            w[w.length] = "\">&#8593;<a class=\"ProxToggleI Prox\" href=\"javascript:prxO.oInt.";
            w[w.length] = "inToggleB('ProxFlash','cl','span,object');\" title=\"Toggle ";
            w[w.length] = prxO.oiFlash; w[w.length] = " Flash Object(s)\" target=\"_self\">flash</a> </span>";
          }

          // See if the style selector should be invoked. - sidki
          var d;
          if (prxO.oSet.$toDo & 2 && (d = document.styleSheets)) {
            for (var i = 0; i < d.length; i++) {
              var s = d[i], tt = s.title, st;
              if (tt != "" && tt != undefined) st = 1;
            }
            if (st) {
              w[w.length] = "<span class=\"ProxBottom Prox\">";
              w[w.length] = "&#8593;<a class=\"ProxBottom Prox\"";
              w[w.length] = " href=\"javascript:prxO.oInt.inStyleSwitch();\">styles</a></span>\n";
            }
          }

          // Intercept calls to "location.replace" Part II. - Paul Rupe, sidki
          if (prxO.inCatchLocURL) {
            w[w.length] = "<span class=\"ProxRedir Prox\">";
            w[w.length] = "&#8593;<a class=\"ProxRedir Prox\" href=\""; w[w.length] = prxO.inCatchLocURL;
            w[w.length] = " \" target=_top>tame redirect</a></span>\n";
          }

          // Various Events to Buttons Part II (page has loaded). - Paul Rupe
          w[w.length] = this.ncButString;
          if (prxO.oSet.$toButton & 1) {
            w[w.length] = this.ncButEvent("window", "onbeforeprint");
            w[w.length] = this.ncButEvent("window", "onafterprint");
            w[w.length] = this.ncButEvent("window", "onblur");
            w[w.length] = this.ncButEvent("window", "onfocus");
            w[w.length] = this.ncButEvent("window", "onscroll");
            w[w.length] = this.ncButEvent("window", "onresize", /\.style\.|\.length\W/);
          }
          if (prxO.oSet.$toButton & 8) {
            var moLo = prxO.oiIsMoz ? "window" : "prxO.oBody",
            moEx = /\.(style\.|altKey|shiftKey)/,
            moIn = /return(\s+| ?\( ?)false|open ?\(|\.(src|href) ?=/;
            w[w.length] = this.ncButEvent(moLo, "onclick", null, moIn);
            w[w.length] = this.ncButEvent(moLo, "onmousedown", null, moIn);
            w[w.length] = this.ncButEvent(moLo, "onmouseup", null, moIn);
            w[w.length] = this.ncButEvent("document", "onclick", moEx, moIn);
            w[w.length] = this.ncButEvent("document", "onmousedown", moEx, moIn);
            w[w.length] = this.ncButEvent("document", "onmouseup", moEx, moIn);
          }
        }

        // Add some attributes to our bottom DIV container.
        if (prxO.oiWinShort)
          prxO.oInt.inSetCSS(prxO.oInt.inDivNode,
            "position: absolute; left: 0; bottom: " +
            ((prxO.oiWinShort == 2) ? 15 : 2) + "px; display: " + wdisp + ";");
        else prxO.oInt.inDivNode.style.display = wdisp;
        prxO.oInt.inDivNode.id = "proxDom-Div";
        this.ncDocFrag.appendChild(prxO.oInt.inDivNode);
        if (w.length) prxO.oInt.inDivNode.innerHTML = w.join("");

        // Append dynamic blocks if there are any already.
        if (this.ncColl) {
          var that = this;
          function addDyn() {
            for (var i = 0, c; c = that.ncColl[i]; i++) prxO.oInt.inDivNode.appendChild(c);
          }
          if (prxO.oiIsOp || prxO.oiIsIE) PrxRLsetTimeout(addDyn, 0);
          else addDyn();
        }
      }

      // Clickable flyover Part II. - Dynamic Drive, sidki, Martin Konicek
      prxO.oFly.flObject = prxO.oInt.inMakeEl("div");
      prxO.oFly.flObject.id = "proxFly-Div";
      prxO.oFly.flObject.onmouseover = prxO.oFly.flClearHide;
      prxO.oFly.flObject.onmouseout = prxO.oFly.flDynHide;
      this.ncDocFrag.appendChild(prxO.oFly.flObject);
    }

    // Register our onload event Part III (re-add -> move to end-of-chain).
    // Executed outside framesets and for standards-compliant browsers only.
    if (!prxO.oiIsIE) prxO.oInt.inEventAdd(window, "load", this.ncLoad);

    // We've reached the end of the page.
    prxCountLd = 1;
  },

  // Run this function at the very last. - ...
  ncFinal : function (pxSplit) {
    var i, z, t, fo, fr, d;

    // Add some info to the title, snip excessively large strings. - sidki
    if (prxO.oSet._titProxy || prxO.oSet._titMod || prxO.oSet._titTime) {
      var pxDp = prxO.oSet._titProxy ? "[Proxy] " : "", pxDt = document.title;
      if (prxO.oSet._titTime) {
        if (pxDt.length > 62) pxDt = pxDt.substr(0, 62) + "...";
        pxDt += " ~" + prxO.oSet._titTime;
      }
      pxDt += prxO.oSet._titMod ? " [" + prxO.oSet._titMod + "]" : "";
      document.title = pxDp + pxDt;
    }

    // Get Window Names Part III.  IE denies access to the "prxO.oTop",
    // if "document.domain" has been changed after the variable was set.
    // So check again.
    try { z = typeof prxO.oTop.prxO.oiNames; }
    catch (er) { prxO.oTop = window; }

    // Get the name of this window and all child frames, if any.
    this.ncTgAdd(window);
    for (i = 0; fr = frames[i]; i++) try { this.ncTgAdd(fr); } catch (er) {}

    // Once the top window has loaded, check the link targets in this window
    // and all child frames.
    if (prxO.oSet.$toDo & 32 && prxO.oTop == window) {
      for (i = 0; fr = frames[i]; i++)
        try { fr.prxO.oInt.inTgLinks(); } catch (er) {}
      prxO.oInt.inTgLinks();
    }

    // Set some of an object's event handlers to null Part II. - Paul Rupe
    if (prxO.oSet.$stopMe & 2) {
      prxO.oInt.inClearEvent(document);
      prxO.oInt.inClearEvent(prxO.oBody);
      prxO.oInt.inClearEvent(window);
    }

    // Proxomitron Menu Part II. - sidki
    if (prxO.oSet.$toDo & 1 && prxO.oSet.$_frameset != 2) {
      if (!prxO.oiWinTiny) {
        prxO.oMen.meWriteI();
        prxO.oInt.inEventAdd(prxO.oiIsMoz ? window : document, "click", prxO.oMen.meInit, true);
      } else {
        delete prxO.oInt.inClearEvent;
        delete prxO.oMen.meSet;
        delete prxO.oMen.meWriteI;
        delete prxO.oMen.meInit;
      }
    }
    else if (prxO.oSet.$_level < 5) delete prxO.oInt.inClearEvent;

    // Append our additions to the page.
    if (prxO.oSet.$_frameset != 2) prxO.oBody.appendChild(this.ncDocFrag);

    // Track last click if interception of popups, timers, or message boxes is
    // turned on. - Scott R. Lemmon
    if (prxO.oSet.$popUp & 1 || prxO.oSet.$stopMe & (4 | 8) || prxO.oSet._catchBoxes)
      prxO.oInt.inEventAdd(document, "mouseup", function () {
        prxO.oiLastClick = prxO.oTop.prxO.oiLastClick =
          new prxO.oiDate().getTime();
      }, true);

    // Page Load Timer Part III. - hpguru
    if (prxO.oSet.$toDo & 16) {
      prxO.oiLdStop = "Load Time (sec): " +
        pxSplit + (new prxO.oiDate().getTime() - prxO.oiLdStart) / 1000;
      if (prxO.oiIsOp)
        PrxRLsetTimeout(function () { status = window.defaultStatus = prxO.oiLdStop; }, 0);
      else status = window.defaultStatus = prxO.oiLdStop;
    }

  },

  // The function that gets registered with the onload event.  Keep it simple
  // to avoid memory leaks in Mozilla.
  ncLoad : function () {

    // If our environment is gone, return (XMLHttpRequest/Ajax).
    if (typeof prxCountLd == "undefined") return;

    // Page Load Timer Part II. - hpguru
    var tsplit = (prxO.oSet.$toDo & 16 && prxO.oSet.$_level > 3) ?
      (new prxO.oiDate().getTime() - prxO.oiLdStart) / 1000 + " -> " : "";

    // If this gets executed and the "ncBottom" function didn't run before,
    // then we are apparently in a frameset.
    // Else, add our stuff to the end of page.
    !prxCountLd ? prxO.oSet.$_frameset = 2 : prxO.oNce.ncWrite();

    // Final jobs.
    prxO.oNce.ncFinal(tsplit);

    // Delete temporary routines that aren't needed anymore.
    if (prxO.oSet.$_level < 5) delete prxO.oNce;

    // All done.
    prxCountLd = 2;
  }

};

/* ====================================
   Clickable flyover Part I. - Dynamic Drive, sidki, Martin Konicek
   ==================================== */

// Pop-it menu - By Dynamic Drive.  For full source code and more DHTML
// scripts, visit http://www.dynamicdrive.com .  This credit MUST stay intact
// for use.
prxO.oFly = {
  flShow : function (which, e, movex) {
    if (!this.flObject) return;
    this.flClearHide();
    this.flHide();
    e = e || window.event;
    var offY = 10;
    this.flObject.innerHTML = (movex == 1) ? which : prxO.oiUesc(which);

    // Find out the mouse position relative to the viewport. - sidki
    var hereX = (e.pageX || prxO.oDoc.scrollLeft + e.clientX) - prxO.oiWidth;
    var hereY = e.pageY || prxO.oDoc.scrollTop + e.clientY;

    // If the mouse is too close to the viewports right or top edge, move
    // the position of the flyover to the left or bottom.
    var pWidth = this.flObject.offsetWidth;
    var pHeight = this.flObject.offsetHeight + offY;
    hereX = (movex && prxO.oDoc.clientWidth - e.clientX < pWidth) ?
      hereX - pWidth : hereX;
    hereY = (e.clientY < pHeight) ? hereY + offY : hereY - pHeight;

    prxO.oInt.inSetCSS(this.flObject, "left: " + hereX + "px; top: " + hereY + "px;");
    this.flIdShow = PrxRLsetTimeout(function () {
      prxO.oFly.flObject.style.visibility = "visible";
    }, 450);
  },

  flDHide : function () {
    prxO.oFly.flClearHide();
    prxO.oFly.flIdShow = PrxRLsetTimeout(prxO.oFly.flHide, 450);
  },

  flHide : function () {
    if (prxO.oFly.flObject) prxO.oFly.flObject.style.visibility = "hidden";
  },

  flClearHide : function () {
    if (prxO.oFly.flIdShow) clearTimeout(prxO.oFly.flIdShow);
  },

  // Make sure that moused-out-from node doesn't contain moused-out-to node.
  // - Peter-Paul Koch
  flDynHide : function (e) {
    e = e || window.event;
    var cdp, rt = e.relatedTarget || e.toElement,
    off = rt ? this.contains ? !this.contains(rt) : this.compareDocumentPosition ?
      !((cdp = this.compareDocumentPosition(rt)) & 16) && cdp : true : true;
    if (off) prxO.oFly.flHide();
  },

  // Make an anchor with the passed information. - Martin Konicek
  flLink : function (dummy, name, url) {
    return "<a class=\"ProxFly-A\" href=\"" + prxO.oiUesc(url) + "\">" + name + "</a>";
  }

};

/* ====================================
   Timers to button -- Intercept "setInterval" and "setTimeout" functions that
   are triggered before the page has completely loaded with a start/stop
   button. - sidki
   ==================================== */

if (prxO.oSet.$stopMe & (4 | 8)) {
  prxO.oTim = {
    tiAppend : function (meth, func, time) {

      // If this is the first call, initialize the variables.
      if (!this.tiColl) {
        this.tiColl = [];
        var rtext = !prxO.oiIsOp ?
          ",%3Cbr class=%22ProxFly-Br%22 />right-click to run once without delay" : "";

        // Escape function code for display.
        var s = func.toString();
        s = s.replace(/&/g, "&amp;");
        s = s.replace(/</g, "&lt;");
        s = s.replace(/>/g, "&gt;");
        s = s.replace(/\r/g, "");
        s = s.replace(/\n/g, "%3Cbr class=%22ProxFly-Br%22 />");
        s = s.replace(/"/g, "&quot;");

        this.tiFirst = {

          // On right-click run the first timer function just once and without
          // delay.  Opera ignores that.
          rclick : function () { PrxRLsetTimeout(func, 0); return false; },

          over : "%3Cspan class=%22ProxFly-Span%22>first instance" + ": " + meth + " " +
            time / 1000 + " second(s)" + rtext + ":%3C/span>%3Cbr class=%22ProxFly-Br%22 />" + s
        };

        // Create the timer button.  "onmouseover" and "oncontextmenu" just
        // deal with the first timer instance.  "onclick" launches all
        // instances.
        this.tiTag = prxO.oInt.inMakeEl("input");
        this.tiTag.className = "ProxBtn-Input";
        this.tiTag.type = "button";
        this.tiTag.value = "timer";
        this.tiTag.onmouseover = function (event) {
          prxO.oFly.flShow('%3Cdiv id=%22proxFlyCt-Div%22>' + prxO.oTim.tiFirst.over + '%3C/div>',event,0);
        };
        this.tiTag.onmouseout = prxO.oFly.flDHide;
        this.tiTag.onclick = prxO.oTim.tiClick;
        this.tiTag.oncontextmenu = prxO.oTim.tiFirst.rclick;

        prxO.oInt.inDOMready(this.tiTag);
      }

      // Append the data of the current timer instance to a "command-line"
      // array.
      this.tiColl[this.tiColl.length] = [meth, func, time];
    },

    // The "onclick" function for the timer button.  Works like a toggle.
    tiClick : function () {
      var i, j, m, ceci = arguments.callee;
      if (!ceci.ids) ceci.ids = [];

      // Case 1:  We've pushed the button before, it displays "stop" now, so
      // that's what we do here.
      if (ceci.start == 1) {
        ceci.start = 0;
        prxO.oTim.tiTag.value = "timer";
        window.setTimeout = function () { return true; };
        window.setInterval = function () { return true; };

        // Stop all previously triggered timer IDs.
        while (ceci.ids.length) {
          i = ceci.ids.shift();
          window.clearTimeout(i);
          window.clearInterval(i);
        }

      // Case 0:  Button displays "timer".  We want to start all captured
      // timers with the current click.
      } else {
        ceci.start = 1;
        prxO.oTim.tiTag.value = " stop ";
        window.setTimeout = PrxRLsetTimeout;
        window.setInterval = PrxRLsetInterval;

        // Run the "command-line" array that contains all timer requests.
        // Trigger a timer with passed params, add the timer ID to another
        // array, so that it can be stopped later.
        for (j = 0; m = prxO.oTim.tiColl[j]; j++)
          ceci.ids[ceci.ids.length] = window["PrxRL" + m[0]](m[1], m[2]);
      }
    }

  };

  // Intercept "setTimeout".
  // Catch all calls which are still running after 10 seconds, or which are
  // scheduled after more than 1 second...
  // ...unless it's Mozilla's internal scrolldelay function for Marquees,
  // or we've clicked into the window within the 10 seconds.
  if (prxO.oSet.$stopMe & 4) window.setTimeout = function (func, time) {
    try { var pT = prxO.oTop.prxO.oiLastClick; } catch (er) {}
    if (!pT && !prxO.oiLastClick && !prxO.oSet.$_frameset) {
      if (!func) return PrxRLsetTimeout(func, time);

      var fn = func.toString(),
      si = /^[^(]*slide/i,
      se = /^(l7[1-9]\(|\n*function myTimeOutFunction|[^(]*menu)/i;
      var fx = fn.substr(0, fn.indexOf("(")); fx += " "; fx += time;

      if (!prxO.oTim.tiCount) prxO.oTim.tiCount = {};
      if (!prxO.oTim.tiCount[fx]) prxO.oTim.tiCount[fx] = 0;
      if ((
           time > 1000 ||
           time > 49 && time * prxO.oTim.tiCount[fx] > 10000 ||
           (!time || time < 50) && prxO.oTim.tiCount[fx] > 200 ||
           fn.search(si) != -1
         ) && fn.search(se) == -1)
        return prxO.oTim.tiAppend("setTimeout", func, time);

      prxO.oTim.tiCount[fx] = ++prxO.oTim.tiCount[fx];
      return PrxRLsetTimeout(func, time);
    }
    window.setTimeout = PrxRLsetTimeout;
    return setTimeout(func, time);
  };

  // Intercept "setInterval".
  if (prxO.oSet.$stopMe & 8) window.setInterval = function (func, time) {
    try { var pT = prxO.oTop.prxO.oiLastClick; } catch (er) {}
    if (!pT && !prxO.oiLastClick) {
      var fn = func.toString(),
      s = /^(_cL\(|TM[a-z]\.TM0|um\.n\.)|clearInterval|\._tryPreloadAttach/;
      if ((time < 13 || time > 40 || fn.indexOf(".apply") == -1) && fn.search(s) == -1)
        return prxO.oTim.tiAppend("setInterval", func, time);
      return PrxRLsetInterval(func, time);
    }
    window.setInterval = PrxRLsetInterval;
    return setInterval(func, time);
  };

}

/* ====================================
   Scope for run-and-forget code.
   ==================================== */

(function () {

  // Inject our Stylesheets. - sidki, JD
  if (!prxO.oSet.$_cssSpec) prxO.oSet.$_cssSpec = [];
  if (prxO.oSet.$css & 2) prxO.oSet.$_cssSpec.push("links");
  if (prxO.oSet.$css & 4)
    prxO.oiIsIE  ? prxO.oSet.$_cssSpec.push("all", "b-ie") :
    prxO.oiIsMoz ? prxO.oSet.$_cssSpec.push("all", "b-moz") :
    prxO.oiIsOp  ? prxO.oSet.$_cssSpec.push("all", "b-op") :
    prxO.oSet.$_cssSpec.push("all");
  if (prxO.oSet.$_cssSpec.length) prxO.oNce.ncCSSAdd();

  // Fix the Location object. - sidki
  // Strip Proxomitron URL commands from the "host", "hostname", and "href"
  // properties.  Set "protocol" to "https:", if the URL command was "https..".
  // Because "Location" cannot be manipulated in IE, we need to create new
  // properties and rename the native ones with a webfilter.
  var pxL = location, pxHn = pxL.hostname, pxR = pxL.href,
  pxRj = pxR.indexOf("?prx-"), pxHi, pxRi;

  pxHi = ((pxHi = pxHn.indexOf("..")) != -1) ?
    pxHi + 2 : ((pxHi = pxHn.indexOf("-px-.")) != -1) ? pxHi + 5 : null;
  pxRi = ((pxRi = pxR.indexOf("..")) != -1) ?
    pxRi + 2 : ((pxRi = pxR.indexOf("-px-.")) != -1) ? pxRi + 5 : null;

  pxL.PRXprotocol = (pxHn.search(/https(\.|-px-)\./) != -1) ? "https:" : pxL.protocol;
  pxL.PRXhostname = pxHi ? pxHn.substr(pxHi) : pxHn;
  pxL.PRXhost = pxHi ? pxL.host.substr(pxHi) : pxL.host;
  if (pxHi && pxRi) pxL.PRXhref = pxL.PRXprotocol + "//" + pxR.substr(pxRi);

  // ".hash", and hence ".href", are dynamic properties in Mozilla.
  else if (pxL.__defineGetter__)
    pxL.__defineGetter__("PRXhref", function() { return location.href; });

  else pxL.PRXhref = pxR;
  if (pxRj != -1) pxL.PRXhref = pxL.PRXhref.substr(0, pxRj);

  // Fix the Navigator object. - sidki
  // The "JSProperties" blocklist is renaming several Navigator properties.
  // These get defined below.
  var pxN, pxU = navigator.PRXuserAgent;
  if (pxU) {
    if ((pxN = pxU.match(/\d[^)]+\)/))) {
      navigator.PRXappVersion = navigator.PRXappMinorVersion = pxN[0];
      navigator.PRXappName =
        (pxU.indexOf("Mozilla/4.0") == 0) ? "Microsoft Internet Explorer" :
        (pxU.indexOf("Mozilla/") == 0) ? "Netscape" :
        (pxU.indexOf("Opera/") == 0) ? "Opera" : "";
      if (pxU.indexOf("Gecko/") > 0) navigator.PRXproduct = "Gecko";
    }
    navigator.PRXcpuClass = "alpha";
    if (navigator.userLanguage) navigator.PRXuserLanguage = "en";
    if (navigator.browserLanguage) navigator.PRXbrowserLanguage = "en";
    if (navigator.systemLanguage) navigator.PRXsystemLanguage = "en";
    navigator.PRXjavaEnabled = navigator.PRXcookieEnabled = true;
  } else {
    pxN = ["userAgent", "appVersion", "appMinorVersion", "appName", "product",
      "cpuClass", "userLanguage", "browserLanguage", "systemLanguage",
      "cookieEnabled"];
    while (pxN.length) navigator["PRX" + pxN[0]] = navigator[pxN.shift()];
  }

  // Permanent handles for the W3C and IE event registration methods.
  var i, pxZ, pxA = [];
  if (window.addEventListener) pxA[pxA.length] = "addEventListener";
  if (window.attachEvent) pxA[pxA.length] = "attachEvent";
  for (i = 0; pxA[i]; i++) {
    pxZ = pxA[i];
    window["PrxRL" + pxZ] = window[pxZ];
    document["PrxRL" + pxZ] = document[pxZ];

    // Various Event Listeners to Buttons Part I (start of page). - sidki
    if (prxO.oSet.$toButton & 2)
      window[pxZ] = document[pxZ] = function (evn, fn, cap) {
        return (
          prxO.oNce.ncButListen(this, evn, fn, cap) ||
          this["PrxRL" + pxZ](evn, fn, cap)
        );
      };
  }

}) ();

/* ====================================
   Prepare node that gets populated later on.
   ==================================== */

prxO.oInt.inDivNode = prxO.oInt.inMakeEl("div");

/* ====================================
   Get Window Names Part II. - z12, sidki
   ==================================== */

// Detect the top window of this document, and if former isn't the current
// window, create a container to store the names of all frames.  "parent" could
// be a window name, so test for it.  Opera requires a further test for
// "document.domain", in order to throw a cross-site security error.
try {
  while (prxO.oTop.parent.name != "parent" &&
         prxO.oTop.parent.document.domain &&
         prxO.oTop != prxO.oTop.parent)
    prxO.oTop = prxO.oTop.parent;
} catch (er) {}

// Opera fires the top window's onload event before the child frames have
// loaded.  Also, an early "window.open" may try to load a page into to an
// existing child frame.  Adding the children's names with the onload function
// would be too late, so we do it now, and once more later.
if (prxO.oTop.prxO && prxO.oTop.prxO.oInt) prxO.oNce.ncTgAdd(window);

/* ====================================
   Register our onload event Part I (first addition). - z12
   Doing it here - the top of page - makes it the last onload event in IE.
   Frameset documents need this as well, because the Proxomitron end-of-page
   script isn't parsed there.  If we are not using IE, and this is not a
   frameset, "ncLoad" will be swapped to the end of the onload chain later.
   ==================================== */

prxO.oInt.inEventAdd(window, "load", prxO.oNce.ncLoad);

/* ====================================
   Anti-Popup Code. - Scott R. Lemmon
   ==================================== */

if (prxO.oSet.$popUp & 1) {
  prxO.oiLastClick = 0;
  prxO.oiIsMoz ? Window.prototype.PrxRLopen = Window.prototype.open :
    PrxRLopen = window.open;

  window.open = function (url, enam, atr, hist) {

    // Make sure that popup windows have desired browser controls.
    function atrSet() {
      var xatr = "location=1,status=1,scrollbars=1,resizable=1" +
        ((prxO.oSet.$popUp & 16) ? ",toolbar=1,menubar=1" : ""),
      odim = atr.match(/left[=:](\d+)/i),
      ndim = screen.width * .01;
      xatr += ",left="; xatr += (odim && odim[1] < ndim) ? odim[1] : ndim;
      odim = atr.match(/top[=:](\d+)/i);
      ndim = screen.height * (prxO.oiIsOp ? .05 : .12);
      xatr += ",top="; xatr += (odim && odim[1] < ndim) ? odim[1] : ndim;
      odim = atr.match(/height[=:](\d+)/i);
      xatr += ",height="; xatr += odim ? odim[1] : 480;
      odim = atr.match(/width[=:](\d+)/i);
      xatr += ",width="; xatr += odim ? odim[1] : 640;
      return xatr;
    }

    // To reroute showModalDialog/showModelessDialog, the second parameter MUST
    // be tested/converted to string if need be since dialogs can also accept
    // objects, whereas "open" only accepts strings as second parameter.
    // A further problem can arise in the third parameter.  The dialog calls
    // have a slightly different format.  Size for instance is passed
    // differently and uses a semicolon instead of an equal sign. - TEggHead
    var ceci = arguments.callee; ceci.count = ++ceci.count || 1;
    var nam = (typeof enam != "string") ? enam ? "Dialog" : "prx_pop_" + ceci.count : enam;

    // IE doesn't support "apply" for window.open, so pass on the correct
    // number of arguments the hard way. - sidki
    var le = arguments.length;
    function argGet() {
      switch (le) {
        case 0  : return PrxRLopen();
        case 1  : return PrxRLopen(url);
        case 2  : return PrxRLopen(url, nam);
        case 4  : return PrxRLopen(url, nam, atr, hist);
        default : return PrxRLopen(url, nam, atr);
      }
    }

    // Allow windows referring to trusted target names - Paul Rupe
    if (enam == nam && prxO.oInt.inTgCheck(nam)) return argGet();

    // If this page has already loaded and the mouse was clicked within
    // 2 seconds, allow the new window.
    var op, ti = new prxO.oiDate().getTime(),
    sc = ti - prxO.oiLastClick < 2000,
    tc = (prxO.oTop == window) ?
      false : ti - prxO.oTop.prxO.oiLastClick < 2000;

    // If the current window already is an onsite popup, fine too. - sidki
    try { op = window.opener.location.href != window.location.href }
    catch (er) {}

    if (op || prxCountLd == 2 && (sc || tc))
      return atr ? (prxO.oSet.$popUp & (8 | 16)) ?
        PrxRLopen(url, nam, atrSet()) : argGet() : PrxRLopen(url, nam);

    // Grab the PopUp URL for notification function.
    prxO.oInt.inPopURL(url);

    return {
      focus : function () {}, blur : function () {}, close : function () {},
      moveTo : function () {}, resizeTo : function () {}
    };
  }

  // IE Specific Methods. - Homeric
  if (prxO.oiIsIE)
    window.showModalDialog = window.showModelessDialog = window.open;
}

/* ====================================
   Prevent Window Resizing Part I. - sidki
   Intercept "window.resizeTo" and "window.moveTo" for all windows except
   popups.  Note that Mozilla/Nescape windows can also be resized with
   "innerWidth=this; outerHeight=that".  This gets blocked the hard way in the
   "JSProperties" list, and - in case of a popup - restored by Part II.
   ==================================== */

if (prxO.oSet.$toDo & 64 && prxO.oiWinNormal) {
  if (prxO.oiIsMoz) {
    Window.prototype.PrxRLmoveTo = Window.prototype.moveTo;
    Window.prototype.PrxRLresizeTo = Window.prototype.resizeTo;
  } else {
    PrxRLmoveTo = window.moveTo;
    PrxRLresizeTo = window.resizeTo;
  }

  window.moveTo = function (pxX, pxY) {
    prxO.oInt.inFooter(3, "moveTo blocked", pxX + "x" + pxY);
    return true;
  };

  window.resizeTo = function (pxX, pxY) {
    prxO.oInt.inFooter(3, "resizeTo blocked",
      pxX ? pxX + " x " + pxY : "proprietary method");
    return true;
  };

  if (prxO.oiIsMoz) window.sizeToContent = window.resizeTo;
}

/* ====================================
   Block randomizers.  Return a constant for calls to the Math.random() method.
   - sidki, z12
   ==================================== */

if (prxO.oSet._catchRnd) {
  Math.PrxRLrandom = Math.random;
  Math.random = function () {
    if (--prxO.oSet._catchRnd > 0) return 0.99999999999999;
    Math.random = Math.PrxRLrandom;
    return Math.random();
  }
}

/* ====================================
   Block various Methods. - Paul Rupe, sidki
   ==================================== */

if (prxO.oSet.$stopMe & 1) {

  // Override some window manipulation APIs (which never should have existed in
  // the first place).
  window.focus =
  window.blur =
  window.resizeBy =
  window.moveBy = PrxVoidF;

  if (prxO.oiIsIE) {
    prxVoidV = function createPopup() {};
    prxVoidV = function clipboardData() {};
    prxVoidV = "";
  }

  // Override these window properties as well.
  function status() { return true; }
}

/* ====================================
   Show error messages in the footer.  IE and Mozilla only for now. - sidki
   ==================================== */

if (prxO.oSet._catchErrors && !prxO.oiIsOp) {
  prxO.oNce.ncOnerror = function (pxMsg, file, line) {
    if (--prxO.oSet._catchErrors >= 0) prxO.oInt.inFooter(4, "JS Error", pxMsg);
    return false;
  }
  window.onerror = prxO.oNce.ncOnerror;
}

/* ====================================
   Restrict Message Boxes. - Paul Rupe, sidki
   ==================================== */

if (prxO.oSet._catchBoxes) {
  if (prxO.oiIsMoz) {
    Window.prototype.PrxRLalert = Window.prototype.alert;
    Window.prototype.PrxRLprompt = Window.prototype.prompt;
    Window.prototype.PrxRLconfirm = Window.prototype.confirm;
  } else {
    PrxRLalert = window.alert;
    PrxRLprompt = window.prompt;
    PrxRLconfirm = window.confirm;
  }

  // Returns true if alert/confirm/prompt have not been called a bunch of times
  // already, false if they have not.  Used to stop runaway scripts abusing
  // these popup functions.
  prxO.oInt.inBoxCheck = function () {
    if (!prxO.oiLastClick || prxO.oSet._catchBoxes == 999) return false;
    if (--prxO.oSet._catchBoxes >= 0) return true;
    if (PrxRLconfirm("*** PROXOMITRON ALERT ***\nThis script is too busy for its own good.  Kill it?")) {
      prxO.oSet._catchBoxes = 999;
      return false;
    }
    return true;
  }

  window.confirm = function (msg) {
    return prxO.oInt.inBoxCheck() ? PrxRLconfirm(msg) :
      (prxCountLd > 1 || --prxO.oSet._catchBoxes >= 7) ?
      prxO.oInt.inFooter(3, "JS Confirm", msg) : null;
  };

  window.prompt = function (msg, d) {
    return prxO.oInt.inBoxCheck() ? PrxRLprompt(msg, d || "") :
      (prxCountLd > 1 || --prxO.oSet._catchBoxes >= 7) ?
      prxO.oInt.inFooter(3, "JS Prompt", msg) : null;
  };

  window.alert = function (msg) {
    return (!(prxO.oSet.$toDo & 4) && prxO.oInt.inBoxCheck()) ? PrxRLalert(msg) :
      (prxCountLd > 1 || --prxO.oSet._catchBoxes >= 7) ?
      prxO.oInt.inFooter(3, "JS Alert", msg) : null;
  };
}

/* ====================================
   Intercept calls to "location.replace" Part I.
   IE and Opera only ("replace" is read-only in Mozilla). - Paul Rupe, sidki
   ==================================== */

if (!prxO.oiIsMoz && prxO.oSet.$toDo & 8 && window.parent == window) {
  PrxRLreplace = location.replace;

  window.location.replace = function (l) {
    if (prxCountLd < 2) { prxO.inCatchLocURL = l; return false; }
    window.location.replace = PrxRLreplace;
    return location.replace(l);
  };
}

/* ====================================
   Proxomitron Menu Part I. - sidki
   ==================================== */

if (prxO.oSet.$toDo & 1) {
  prxO.oMen = {

    // Prepare icon insertion.
    mePics : [new Image(), new Image()],
    meWriteI : function () {
      this.meImg = prxO.oInt.inMakeEl("img");
      this.meImg.id = "proxM-Img";
      this.meImg.src = this.mePics[0].src;
      this.meImg.alt = prxO.oiIsIE ? "" : "Prox";
      this.meImg.onmouseover = function () { this.src = prxO.oMen.mePics[1].src; prxO.oMen.meShow(); };
      this.meImg.onmouseout = function () { this.src = prxO.oMen.mePics[0].src; prxO.oMen.meHide(); };
      this.meImg.onclick = function () { this.style.display="none"; };
      prxO.oNce.ncDocFrag.appendChild(this.meImg);
    },

    // Initialize the menu upon first mouse click.
    meInit : function (e) {
      e = e || window.event;
      var tag = e.target || e.srcElement, nam = tag.tagName.toLowerCase(), par;
      if (e.button || nam == "a" || nam == "input" ||
          (par = tag.parentNode.tagName && par && par.toLowerCase() == "a"))
        return;
      prxO.oMen.meTimer = 0;

      // Set some of an object's event handlers to null Part III. - Paul Rupe
      if (prxO.oSet.$stopMe & 2) prxO.oInt.inClearEvent(document);

      // Prepare menu insertion.
      prxO.oMen.meDiv = prxO.oInt.inMakeEl("div");
      prxO.oMen.meDiv.id = "proxM-Div";
      var tg = "/local.ptron/sidki_h_" + prxO.oSet.$_cfg + "/proxjs-x-menu.js";
      function doAppend(s) {
        if (s) eval(XHR.responseText);
        else {
          var tagS = prxO.oInt.inMakeEl("script");
          tagS.src = "http:/" + tg;
          tagS.type = "text/javascript";
          tagS.id = "proxScrMenu";
          prxO.oBody.appendChild(tagS);
        }
      }

      // Get menu data.  Use XMLHttpRequest if supported, else fall back to
      // slower standard request.
      var XHR = window.XMLHttpRequest ? new XMLHttpRequest() : null;
      if (!XHR && window.ActiveXObject)
        for (var i = 0, msXHR = [6, 4, 3], m; m = msXHR[i]; i++)
          try { XHR = new ActiveXObject("MSXML2.XMLHttp." + m + ".0"); break; }
          catch (er) {}
      if (!XHR || prxO.oMen.meSet[7] || !location.host) doAppend(0);
      else {
        XHR.open("GET", location.protocol + "//" + location.host + tg);
        XHR.onreadystatechange = function () {
          if (XHR.readyState != 4) return;
          doAppend(1); XHR = null;
        };
        XHR.send(null);
      }

      function miHide() {
        if (prxO.oMen.meImg.style.visibility == "visible")
          PrxRLsetTimeout(function () { prxO.oMen.meImg.style.visibility = "hidden"; }, 150);
      }

      function miShow(e) {
        e = e || window.event;
        var tag = e.target || e.srcElement, nam = tag.tagName.toLowerCase(), par;
        if (e.button || nam == "a" || nam == "input" ||
            (par = tag.parentNode.tagName && par && par.toLowerCase() == "a"))
          return;
        if (prxO.oSet.$toDo & 16)
          status = window.defaultStatus = prxO.oTop.prxO.oiLdStop;
        if (prxO.oMen.meImg.style.visibility == "visible") return;
        prxO.oInt.inSetCSS(prxO.oMen.meImg, "left: " +
          ((window.pageXOffset || prxO.oDoc.scrollLeft) +
          prxO.oDoc.clientWidth - prxO.oiWidth - 50) +
          "px; top: " + ((window.pageYOffset || prxO.oDoc.scrollTop) +
          prxO.oDoc.clientHeight - 50) + "px; visibility: visible;");
      }

      prxO.oInt.inEventRem(prxO.oiIsMoz ? window : document, "click", prxO.oMen.meInit, true);
      prxO.oInt.inEventAdd(prxO.oiIsMoz ? window : document, "click", miShow, true);
      if (prxO.oiIsMoz) prxO.oInt.inEventAdd(window, "DOMMouseScroll", miHide);
      if (!prxO.oiIsIE) prxO.oInt.inEventAdd(window, "resize", miHide);
      prxO.oInt.inEventAdd(window, "scroll", miHide);
      miShow(e);

      if (prxO.oSet.$_level < 5) {
        delete prxO.oInt.inClearEvent;
        delete prxO.oMen.meWriteI;
        delete prxO.oMen.meInit;
      }

    },

    // Show/hide the menu.
    meShow : function () {
      clearTimeout(this.meTimer);
      if (this.meDiv.style.visibility == "visible") return;
      this.meTimer = PrxRLsetTimeout(function () {
        prxO.oInt.inSetCSS(prxO.oMen.meDiv, "left: " +
          ((window.pageXOffset || prxO.oDoc.scrollLeft) +
          prxO.oDoc.clientWidth - prxO.oiWidth - prxO.oMen.meDiv.offsetWidth - 50) +
          "px; top: " + ((window.pageYOffset || prxO.oDoc.scrollTop) +
          prxO.oDoc.clientHeight - prxO.oMen.meDiv.offsetHeight - 50) +
          "px; visibility: visible;");
      }, 150);
    },
    meHide : function () {
      clearTimeout(this.meTimer);
      if (this.meDiv.style.visibility == "hidden") return;
      this.meTimer = PrxRLsetTimeout(function () {
        prxO.oMen.meDiv.style.visibility = "hidden";
      }, 150);
    }

  };

  prxO.oMen.mePics[0].src = "http://local.ptron/sidki_h_" + prxO.oSet.$_cfg + "/proxm-cold.gif";
  prxO.oMen.mePics[1].src = "http://local.ptron/sidki_h_" + prxO.oSet.$_cfg + "/proxm-hot.gif";
}
